/**
  PasswordMaker - Creates and manages passwords
  Copyright (C) 2005 Eric H. Jung and LeahScape, Inc.
  http://passwordmaker.org/
  grimholtz@yahoo.com

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or (at
  your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESSFOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
  for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
**/

var domainsTree, newDomainBtn;

function initDomainsPanel() {
  domainsTree = document.getElementById("domainsTree");
  newDomainBtn = document.getElementById("newDomainBtn");
  domainsTree.database.AddDataSource(passwordMakerHelper.datasource);
  domainsTree.builder.rebuild();
  domainsTree.view.selection.select(0);
}

function onDomainsTreeKeyPress() {
}

function onDomainsTreeSelected() {
  if (domainsTree.currentIndex == -1) {
    // Nothing selected. select the first item
    domainsTree.view.selection.select(0);
    return;
  }
  // If not a folder, generate password
  newDomainBtn.disabled = domainsTree.view.getItemAtIndex(domainsTree.currentIndex).getAttribute("container") != "true";
}

function onNewDomainFolder() {
  createNewFolder("domainid", "domaindesc", passwordMakerHelper.domainsContainer);
}

function onNewDomain() {
  var folderRes = getSelectedItemAsResource(domainsTree);
  if (!folderRes)
    return;

  var folderInfo = "";
  while (folderInfo == "") {
    folderInfo = promptForTwoItems("Domain Name (required)", "Description (optional)");
    if (!folderInfo)
      return;  // user cancelled

    folderInfo.folderName = folderInfo.folderName.replace(" ", ""); // trim any space
    folderInfo.folderName = folderInfo.folderName.toLowerCase();
    if (folderInfo.folderName[0] == ".")
      folderInfo.folderName = folderInfo.folderName.substring(1); // trim leading dot, if any

    if (folderInfo.folderName.indexOf(".") == -1 ) {
      folderInfo = "";
      passwordMakerHelper.prompts.alert(this, "PasswordMaker", "Invalid format. Entries must be of the form a.b.c.d.e.f.g");
    }
    else if (folderInfo.folderName.indexOf("'") > -1 || folderInfo.folderName.indexOf("\"") > -1) {
      folderInfo = "";
      passwordMakerHelper.prompts.alert(this, "PasswordMaker", "Quotes are not permitted in domain names.");
    }
    else {
      for (var j in passwordMaker.domains) {
        if (j == folderInfo.folderName) {
          passwordMakerHelper.prompts.alert(this, "PasswordMaker", j + " already exists in the special domains list.");
          folderInfo = "";
          return;
        }
      }
    }
  }

  var containerRes = passwordMakerHelper.rdfContainerUtils.MakeSeq(passwordMakerHelper.datasource, folderRes);

  // Build the resources...
  // domain name
  var domainRes = passwordMakerHelper.rdfService.GetAnonymousResource();
  _updateDatasourceTarget(domainRes, "domainid", folderInfo.folderName);

  // domain description
  _updateDatasourceTarget(domainRes, "domaindesc", folderInfo.folderDescription);

  // Add the resource to the container (folder)
  containerRes.AppendElement(domainRes);
  passwordMakerHelper.datasourceFlusher.Flush();

  eval("passwordMaker.domains['" + folderInfo.folderName + "'] = true;");

  // Open the selected item (the parent folder of the new domain we just created)
  // if it's not already open.
  if (!domainsTree.view.isContainerOpen(domainsTree.currentIndex))
    domainsTree.view.toggleOpenState(domainsTree.currentIndex);

  // @TODO: Select the last item in the now-open folder (the newly-created account)
}

function onRemoveDomainSelection() {
  var subject = getSelectedItemAsResource(domainsTree);
  if (!subject)
    return;

  var cells = getSelectedTreeCells(domainsTree);
  var domainName = cells[0].getAttribute("label");
  var targetRes = passwordMakerHelper.rdfService.GetLiteral(domainName);
  var domainIdPredicateRes = passwordMakerHelper.rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#domainid");

  // User can't delete system-defined domains
  if (!passwordMakerHelper.datasource.HasAssertion(subject, domainIdPredicateRes, targetRes, true)) {
    passwordMakerHelper.prompts.alert(this, "PasswordMaker", "You cannot delete system-defined domains.");
    return;
  }
  deleteTreeItem(domainsTree, passwordMakerHelper.domainsContainer);
  eval("delete passwordMaker.domains['" + domainName + "'];");
}
