/**
  PasswordMaker - Creates and manages passwords
  Copyright (C) 2005 Eric H. Jung and LeahScape, Inc.
  http://passwordmaker.org/
  grimholtz@yahoo.com

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or (at
  your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESSFOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
  for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
**/
var passwordMaker = {
  listening : "false",
  appcontent : null,
  domains : null,
  passwordMakerHelper : null,
  advancedOptionsDialog : "false", // which dialog to open -- advanced options or basic
  passwordShortcut : "pop-all", // off, pop-all, empty-only, clear-all
  whereLeetLBPredicateRes : null,
  leetLevelLBPredicateRes : null,
  hashAlgorithmLBPredicateRes : null,
  passwordLengthPredicateRes : null,
  urlToUsePredicateRes : null, //http://passwordmaker.mozdev.org/rdf#urlToUse
  urlToMatchPredicateRes : null, //http://passwordmaker.mozdev.org/rdf#urlToMatch
  usernameTBPredicateRes : null,
  counterPredicateRes : null,
  namePredicateRes : null,
  descriptionPredicateRes : null,
  protocolCBPredicateRes : null,
  subdomainCBPredicateRes : null,
  domainCBPredicateRes : null,
  pathCBPredicateRes : null, 
  defaultSubjectRes : null, //http://passwordmaker.mozdev.org/defaults
  //global settings
  globalSettingsSubjectRes : null, //http://passwordmaker.mozdev.org/globalSettings
  masterPasswordPredicateRes : null, //http://passwordmaker.mozdev.org/rdf#masterPassword
  masterPasswordKeyPredicateRes : null,
  masterPasswordStoragePredicateRes : null,
  maskMasterPasswordPredicateRes : null,
  autoClearClipboardPredicateRes : null,
  autoClearClipboardSecondsPredicateRes : null,
  autoPopulatePredicateRes : null,
  advancedOptionsDialogPredicateRes : null,
  charsetPredicateRes : null,
  prefixPredicateRes : null,
  suffixPredicateRes : null,
  passwordShortcutPredicateRes : null,
  //settingsFilePathPredicateRes : null,
  maskMPWFieldPredicateRes : null,
  accountsSubjectRes : null,
  domainsSubjectRes : null,
  domainsDatasource : null,

  init : function() {
    this.appcontent = document.getElementById("appcontent");   // Browser
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
    this.whereLeetLBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#whereLeetLB");
    this.leetLevelLBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#leetLevelLB");
    this.hashAlgorithmLBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#hashAlgorithmLB");
    this.passwordLengthPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#passwordLength");
    this.urlToUsePredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#urlToUse");
    this.urlToMatchPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#urlToMatch");
    this.usernameTBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#usernameTB");
    this.counterPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#counter");
    this.namePredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#name");
    this.descriptionPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#description");
    this.protocolCBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#protocolCB");
    this.subdomainCBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#subdomainCB");
    this.domainCBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#domainCB");
    this.pathCBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#pathCB");
    this.charsetPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#charset");
    this.prefixPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#prefix");
    this.suffixPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#suffix");

    this.defaultSubjectRes = rdfService.GetResource("http://passwordmaker.mozdev.org/defaults");
    this.accountsSubjectRes = rdfService.GetResource("http://passwordmaker.mozdev.org/accounts");
    this.domainsSubjectRes = rdfService.GetResource("http://passwordmaker.mozdev.org/domains");
    
    //global settings
    this.globalSettingsSubjectRes = rdfService.GetResource("http://passwordmaker.mozdev.org/globalSettings");
    this.masterPasswordPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#masterPassword");
    this.masterPasswordKeyPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#masterPasswordKey");
    this.masterPasswordStoragePredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#masterPasswordStorage");
    this.maskMasterPasswordPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#maskMasterPassword");
    this.autoClearClipboardPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#autoClearClipboard");
    this.autoClearClipboardSecondsPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#autoClearClipboardSeconds");
    this.autoPopulatePredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#autoPopulate");
    this.advancedOptionsDialogPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#advancedOptionsDialog");
    this.passwordShortcutPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#passwordShortcut");
    //this.settingsFilePathPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#settingsFilePath");
    this.maskMPWFieldPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#maskMasterPassword");
    this.passwordMakerHelper = new PasswordMakerHelper();

    // Get MPW if it's been saved to disk
    var oMasterPassword = new MasterPassword(this._getLiteral(this.globalSettingsSubjectRes, this.masterPasswordPredicateRes), // Might be null if user doesn't like to save the master pw
                                             this._getLiteral(this.globalSettingsSubjectRes, this.masterPasswordKeyPredicateRes));

    this.passwordMakerHelper.setEncryptedMasterPassword(oMasterPassword);

    // Which dialog is the preferred one (basic or advanced)?
    this.advancedOptionsDialog = this._getLiteral(this.globalSettingsSubjectRes, this.advancedOptionsDialogPredicateRes);

    // Password Shortcut (ALT-`)
    this.passwordShortcut = passwordMaker._getLiteral(passwordMaker.globalSettingsSubjectRes, passwordMaker.passwordShortcutPredicateRes);;

    this.loadDomains();

    // Should we automatically start listening for pageLoads?
    listening = this._getLiteral(this.globalSettingsSubjectRes, this.autoPopulatePredicateRes) == "true";
    if (listening)
      this.installListener();

    // listen for context-menu
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", this.contextPopupShowing, false);
  },

  /**
   * Load the list of top-level domains which require second-level
   * domains (e.g., uk) or third, fourth, fifth-level (etc...) domains
   * into this.domains associative array.
   */
  loadDomains : function() {
    this.domains = new Array();
    var compositeDS = Components.classes["@mozilla.org/rdf/datasource;1?name=composite-datasource"].getService(Components.interfaces.nsIRDFCompositeDataSource);
    compositeDS.AddDataSource(this.passwordMakerHelper.datasource);
    compositeDS.AddDataSource(this.passwordMakerHelper.rdfService.GetDataSourceBlocking("chrome://passwdmaker/content/domains.rdf"));

    var domainsContainer = this.passwordMakerHelper.rdfContainerUtils.MakeSeq(compositeDS, this.domainsSubjectRes);
    var domains = domainsContainer.GetElements();
    while (domains.hasMoreElements()) {
      var country = domains.getNext();
      if (country instanceof Components.interfaces.nsIRDFResource) {
        var countryContainer = this.passwordMakerHelper.rdfContainerUtils.MakeSeq(compositeDS, country)
        var subdomains = countryContainer.GetElements();
        while (subdomains.hasMoreElements()) {
          var subdomain = subdomains.getNext();
          if (subdomain instanceof Components.interfaces.nsIRDFResource) {
            if (!this.passwordMakerHelper.rdfContainerUtils.IsContainer(compositeDS, subdomain)) {
              var sValue = subdomain.Value.substring(subdomain.Value.lastIndexOf("/")+1);
              if (sValue.indexOf("'") > -1)
                continue; // skip bad data
              eval("this.domains['" +  sValue + "'] = true;");
            }
          }
        }
      }
    }
  },

  /**
   * Callback function called by Mozilla when a page loads,
   * if installListener() has been called.
   */
  contextPopupShowing : function() {
    var target = gContextMenu.target;
    // target can be null when opening something like
    // chrome://passwdmaker/chrome/uris.xul directly in the browser.
    if (target) {
      var type = target.type; // always lower-case
      document.getElementById("passwordmaker").hidden = !(type && type == "password");
      // Save a reference to the object being clicked
      passwordMaker.clickedElement = gContextMenu.target;
    }
  },

  /**
   * Callback function called by Mozilla when the context-menu
   * item has been clicked
   */
  onContextMenuClick : function() {
    if (passwordMaker.clickedElement) {
      passwordMaker.clickedElement.value = passwordMaker._generateSiteSpecificPassword();
      passwordMaker.clickedElement = null; // Remove reference to the saved element which was saved in contextPopupShowing()
    }
  },

  /**
   * Given a subject and predicate, return the literal
   * of the associated target (we're assuming there's
   * only a single target). If the target doesn't exist
   * or isn't a literal, return null.
   */
  _getLiteral : function(subjectRes, predicateRes) {
    var targetRes = passwordMaker.passwordMakerHelper.datasource.GetTarget(subjectRes, predicateRes, true);
    return targetRes instanceof Components.interfaces.nsIRDFLiteral ? targetRes.Value : null;
  },

  /**
   * Generate the site-specific password and return it. If there are any
   * problems decrypting the master password, throw an exception.
   */
  _generateSiteSpecificPassword : function() {

    var decryptedMasterPassword = passwordMaker.passwordMakerHelper.getDecryptedMasterPassword();
    if (decryptedMasterPassword == null)
      return ""; // user might simply have hit the cancel button when prompted.

    var accounts = passwordMaker._getAccountSubjects(passwordMaker._getURI());
    var selectedSubjectRes;
    if (accounts.length == 0) {
      // Use the default settings
      selectedSubjectRes = passwordMaker.defaultSubjectRes;
    }
    else if (accounts.length == 1) {
        // There's only one account for this URL
        selectedSubjectRes = accounts[0];
        var name = passwordMaker._getLiteral(accounts[0], passwordMaker.namePredicateRes);
        var description = passwordMaker._getLiteral(accounts[0], passwordMaker.descriptionPredicateRes);
        var username = passwordMaker._getLiteral(accounts[0], passwordMaker.usernameTBPredicateRes);
      }
    else {
      // There are multiple accounts for this URL. Prompt the user for which one to use
      var params = {inn:{accounts : accounts, passwordMaker : passwordMaker}, out:null};
      window.openDialog("chrome://passwdmaker/chrome/chooseaccount.xul", "",
          "chrome, dialog, modal, resizable=yes", params).focus();
      if (params.out) {
        // User clicked OK
        selectedSubjectRes = params.out.selection;
      }
      else {
        // User clicked cancel
        return null;
      }
    }

    var hashAlgorithm = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.hashAlgorithmLBPredicateRes),
      whereLeet = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.whereLeetLBPredicateRes),
      leetLevel = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.leetLevelLBPredicateRes),
      passwordLength = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.passwordLengthPredicateRes),
      protocol = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.protocolCBPredicateRes),
      subdomain = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.subdomainCBPredicateRes),
      domain = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.domainCBPredicateRes),
      path = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.pathCBPredicateRes),
      charset = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.charsetPredicateRes),
      prefix = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.prefixPredicateRes),
      suffix = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.suffixPredicateRes);

    var uri = "", usernameTB = "", counter = "";
    if (selectedSubjectRes == passwordMaker.defaultSubjectRes) {
      // Determine which part(s) of the URI to use in the password generation algorithm
      uri = passwordMaker.calculateURI(protocol == "true",
                                        subdomain == "true",
                                        domain == "true",
                                        path == "true", //@TODO: change this to port when supported in the GUI
                                        path == "true");
    }
    else {
      uri = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.urlToUsePredicateRes);
      usernameTB = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.usernameTBPredicateRes);
      counter = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.counterPredicateRes);
    }

    // Generate the site-specific password
    var ret = passwordMaker.passwordMakerHelper.generatepassword(hashAlgorithm, decryptedMasterPassword,
                          uri + usernameTB + counter, whereLeet, leetLevel, passwordLength, charset, prefix, suffix);

    //dump(ret + "\n");
    // Just to be safe, don't wait for the garbage collector to reclaim the clear-text master password in memory.
    // Even though the variable is on the calling stack (not the heap) and probably doesn't get garbage-collected
    // (I just don't know enough about Mozilla's JavaScript interpreter) -- just tossed -- we set the value to null.
    // This also ensures the stack frame contents -- which probably still exist after the function returns (at least
    // until function calls of the same depth occur) -- can't be inspected to find the decrypted password.
    decryptedMasterPassword = null;
    return ret;

  },

  _getAccountSubjects : function(url) {
    var ret = new Array();
    var resEnum = passwordMaker.passwordMakerHelper.datasource.GetAllResources();
    while (resEnum.hasMoreElements()) {
      var subjectRes = resEnum.getNext(); // e.g., http://passwordmaker.mozdev.org/yahoo/tom_cruise
      var target = passwordMaker.passwordMakerHelper.datasource.GetTarget(subjectRes, passwordMaker.urlToMatchPredicateRes, true);
      if (target instanceof Components.interfaces.nsIRDFLiteral){
        var urlToMatch = target.Value;
        if (url.indexOf(urlToMatch) > -1) {
          ret.push(subjectRes);
        }
      }
    }
    return ret;
  },
/*

    var targetRes = passwordMaker.passwordMakerHelper.rdfService.GetLiteral(target);
    var subjectRes = passwordMaker.passwordMakerHelper.datasource.GetSources(passwordMaker.urlToMatchPredicateRes, targetRes, true);
    // Convert nsISimpleEnumeration to array
    var ret = new Array();
    while (subjectRes.hasMoreElements())
      ret.push(subjectRes.getNext());
    return ret;
  },*/

  /**
   * Callback function called by Mozilla when a page loads,
   * if installListener() has been called.
   */
  pageLoad : function(evt) {
    var doc = evt.originalTarget; // doc is document that triggered "onload" event
    passwordMaker._populatePasswordFields(doc, "pop-all");
  },

  /**
   * Populate the password fields in _doc_
   * with the generated password.
   */
  _populatePasswordFields : function(doc, action) {
    var inputElements = doc.getElementsByTagName("input"); // don't check just for input elements in *forms*!
    var generatedPassword = null;
    for (var i=0; i<inputElements.length; i++) {
      if (inputElements[i].type == "password") { // .type is always lower-case
        if (action == "clear-all") {
          inputElements[i].value = "";
          return;
        }
        if (action == "pop-all" || (action == "empty-only" && inputElements[i].value == "")) {
          // generate the password for this page if it hasn't already been generated
          if (generatedPassword == null)
            generatedPassword = passwordMaker._generateSiteSpecificPassword();
          inputElements[i].value = generatedPassword;
        }
      }
    }
  },

  populatePasswordFields : function() {
    // off, pop-all, empty-only, clear-all
    if (passwordMaker.passwordShortcut == "off")
      return;

    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var recentWindow = wm.getMostRecentWindow("navigator:browser");
    if (recentWindow)
      passwordMaker._populatePasswordFields(recentWindow.content.document, passwordMaker.passwordShortcut);
  },

  /**
   * Start watching for loading pages
   */
  installListener : function() {
    if (this.listening != "true") {
      this.listening = "true";
      this.appcontent.addEventListener("load", this.pageLoad, true);
    }
  },

  /**
   * Stop watching for loading pages
   */
  uninstallListener : function() {
    if (this.listening == "true") {
      this.listening = "false";
      this.appcontent.removeEventListener("load", this.pageLoad, true);
    }
  },

  /**
   * Open the main PasswordMaker dialog
   */
  open : function() {
    // If there's a passwordmaker dialog window already open,
    // just focus it and return.
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var e = wm.getEnumerator("passwordmaker");
    if (e.hasMoreElements()) {
      var passwordmakerInstance = e.getNext(); 
      passwordmakerInstance.focus();
      return;
    }
    // No open passwordmaker dialog.
    // We don't really need a 10 msec delay here, but this lets me
    // easily re-use all the code in the _open() method.
    setTimeout(this._open, 10);
  },

  /**
   * setTimeout() callback function.
   */
  _open : function() {
    // Basic options dialog is resizable because we open it with
    // a specific size in pixels (how to specify in ems?) The entire
    // dialog contents use ems, but if we open in pixels it could look
    // weird on some resolutions/font sizes, so we give the user the
    // option to resize it. Opening the dialog in ems would get around
    // this problem and we could make resizable false.
    var xulfilename = passwordMaker.advancedOptionsDialog == "true" ? "chrome://passwdmaker/content/advanced-options.xul" : "chrome://passwdmaker/content/basic-options.xul";
    passwordMaker.dlg = window.openDialog(xulfilename, "", "dialog,chrome,resizable=yes", {passwordMakerHelper : passwordMaker.passwordMakerHelper});
    passwordMaker.dlg.focus();
  },

  /**
   * Switch from basic options to advanced, or vice-versa.
   * Update the preferences.
   */
  switchOptionsDialog : function() {
    this.advancedOptionsDialog = this.advancedOptionsDialog == "true" ? "false" : "true";
    passwordMaker.passwordMakerHelper.saveGlobalSetting("advancedOptionsDialog", this.advancedOptionsDialog);

    // Inspired by delayedOpenWindow() in browser.js.
    setTimeout(this._open, 10);
  },

  /**
   * Called by calculateURI()
   */
  _parseURI : function(aURI) {
    var temp = aURI.match("([^://]+://)([^/:]*):?([0-9]*)(.*)");  // \d isn't working in place of [0-9], why not?
    if (!temp)
      throw this;
    return { protocol: temp[1],
             domains : temp[2].split("."), // temp[2] is the url without protocol, port, path, query parms, anchor
             port    : temp[3],
             path    : temp[4]};
  },

  _getURI : function() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var recentWindow = wm.getMostRecentWindow("navigator:browser");
    if (recentWindow)
      return new String(recentWindow.content.document.location);
    else
      return "";
  },

  calculateURI : function(includeProtocol, includeSubdomain, includeDomain, includePort, includePath) {

    var aURI = passwordMaker._getURI();
    if (includeProtocol && includeSubdomain && includeDomain && includePath && includePath)
      return aURI;

    if (!includeProtocol && !includeSubdomain && !includeDomain && !includePath && !includePath)
      return "";
    
    var uriComponents;
    try {
      uriComponents = this._parseURI(aURI);
    }
    catch (e) {
      return aURI; // aURI isn't parsable; e.g., about:config, javascript:, about:blank
    }

    var ret = includeProtocol ? uriComponents.protocol : ""; // set the protocol or empty string

    // Check if, for example, domains['co.uk'] == true
    var TLDrequiresSLD = eval("passwordMaker.domains['" + uriComponents.domains[uriComponents.domains.length-2] + "." +
                            uriComponents.domains[uriComponents.domains.length-1] + "']");


    // TODO: logic for third-level domains !

    if (includeSubdomain) {
      // The subdomains are all domains except the final two, unless
      // the TLD is a ccTLD which requires a SLD. In the latter case,
      // the subdomains are all domains except the final three.
      var len = TLDrequiresSLD ? uriComponents.domains.length-3 : uriComponents.domains.length-2;
      for (var i=0; i<len; i++) {
        ret += uriComponents.domains[i];
        // Add a dot if this isn't the final subdomain
        if (i+1 < len)
          ret += ".";
      }			
    }

    if (includeDomain) {
      if (ret != "" && ret[ret.length-1] != "." && ret[ret.length-1] != "/")
        ret += ".";

      if (uriComponents.domains.length == 1) {
        // e.g., localhost (no .com or other domains)
        ret += uriComponents.domains[0];
      }
      else {
        // The domain for a ccTLD which requires SLD is really SLD+ccTLD;
        // e.g., ac.uk instead of just .uk
        if (TLDrequiresSLD)
          ret += uriComponents.domains[uriComponents.domains.length-3] + ".";
        ret += uriComponents.domains[uriComponents.domains.length-2] + "." + uriComponents.domains[uriComponents.domains.length-1];
      }
    }

    if (includePort)
      ret += ":" + uriComponents.port;

    if (includePath)
      ret += uriComponents.path;

    return ret;
  }
};